## @file
# subroutine to calculate the best Signal to Noise ratio

## @method void calculate_Signal2Noise()
# Allows the user interactivetily to calculate the best S/N
# @param fits_file Fits File Name
# @return Void

#======================================================================== 

sub calculate_Signal2Noise(){ 
	
	print "\n----> Running calculate_Signal2Noise ..... \n"; if
	($Log_Flag == 0) {print MYOUTFILE "\n----> Running calculate_Signal2Noise ....\n";}

	$event_list = $_[0];
	my $instrument = $_[1];	
	my $exposure = $_[2];
	my $mode = $_[3];
	&show_ds9($event_list,$instrument,$exposure,$mode,"PG");
	
	print "Continue...";

}

## @method void show_ds9($fits_file, $instrument)
# Display an image file (call to ds9)
# @param fits_file Fits File Name
# @param instrument
# @return Void

#========================================================================
sub show_ds9(){
 	use vars qw($PG_flagCall
	 );
	 
	$fits_file    = $_[0];
	my $instrument   = $_[1];
	my $exposure = $_[2];
	my $mode = $_[3];
	my $type = $_[4];
	
	my $src_expression = '';
	my $bkg_expression = '';
	my $bkg_flag = 0;
	my $src_exclude_flag = 0;
	my $bkg_exclude_flag = 0;

	#.. Define variables per type and instrument
	my $src_expr = $type."_" . $instrument . "_src_expr";
	my $bkg_expr = $type."_" . $instrument . "_bkg_expr";
	my $src_region = $type."_" . $instrument . "_srcregion";
	my $bkg_region = $type."_" . $instrument . "_bkgregion";

	#.. Source Regions...
	my $src_region_X  = $type."_" . $instrument . "_srcregion_X";
	my $src_region_Y  = $type."_" . $instrument . "_srcregion_Y";
	my $src_region_R1 = $type."_" . $instrument . "_srcregion_R1";
	my $src_region_R2 = $type."_" . $instrument . "_srcregion_R2";
	my $src_region_XLength =
	  $type."_" . $instrument . "_srcregion_XLength";
	my $src_region_YLength =
	  $type."_" . $instrument . "_srcregion_YLength";

	#.. Bkg Regions...
	my $bkg_region_X  = $type."_" . $instrument . "_bkgregion_X";
	my $bkg_region_Y  = $type."_" . $instrument . "_bkgregion_Y";
	my $bkg_region_R1 = $type."_" . $instrument . "_bkgregion_R1";
	my $bkg_region_R2 = $type."_" . $instrument . "_bkgregion_R2";
	my $bkg_region_XLength =
	  $type."_" . $instrument . "_bkgregion_XLength";
	my $bkg_region_YLength =
	  $type."_" . $instrument . "_bkgregion_YLength";

	#.. Area Factor
	my $epic_areafactor = $type."_" . $instrument . "_areafactor";
	


	%Switch = (
		'circle'    => sub { print "Parsing a Circle\n";
							$_[3] =~ s/"//;	
							$shape = uc($_[0]);												
							if ($bkg_flag eq 0)	{								
								if ($src_expression =~ /IN/) {$src_expression = $src_expression." && "; }
								if ($src_exclude_flag eq 1) {$src_expression = $src_expression."!";}
								$gv->$src_region($shape);
								$gv->$src_region_X($_[1]);
								$gv->$src_region_Y($_[2]);
							 	$gv->$src_region_R1($_[3]);
								
								$src_expression = $src_expression." ((X,Y) IN $shape($_[1],$_[2],$_[3])) ";}													
							else {								
								if ($bkg_expression =~ /IN/) {$bkg_expression = $bkg_expression." && "; }
								if ($bkg_exclude_flag eq 1)  {$bkg_expression = $bkg_expression."!";}
								$gv->$bkg_region("circle");
								$gv->$bkg_region_X($_[1]);
								$gv->$bkg_region_Y($_[2]);
							 	$gv->$bkg_region_R1($_[3]);

								$bkg_expression = $bkg_expression." ((X,Y) IN $shape($_[1],$_[2],$_[3])) ";
								$bkg_flag = 0;}		
							
							$gv->$src_expr($src_expression);
							$gv->$bkg_expr($bkg_expression);	
							print "SOURCE: $src_expression\n";
       						print "BACKGROUND: $bkg_expression\n";							
						   },
    	'annulus'   => sub { print "Parsing a Annulus\n";
    						$_[3] =~ s/"//;
    						$_[4] =~ s/"//;	
							$shape = uc($_[0]);												
							if ($bkg_flag eq 0)	{								
								if ($src_expression =~ /IN/) {$src_expression = $src_expression." && "; }
								if ($src_exclude_flag eq 1) {$src_expression = $src_expression."!";}
								$gv->$src_region($shape);
								$gv->$src_region_X($_[1]);
								$gv->$src_region_Y($_[2]);
							 	$gv->$src_region_R1($_[3]);
							 	$gv->$src_region_R2($_[4]);

								$src_expression = $src_expression." ((X,Y) IN $shape($_[1],$_[2],$_[3],$_[4])) ";
							
							}													
							else {								
								if ($bkg_expression =~ /IN/) {$bkg_expression = $bkg_expression." && "; }
								if ($bkg_exclude_flag eq 1)  {$bkg_expression = $bkg_expression."!";}
								$gv->$bkg_region($shape);
								$gv->$bkg_region_X($_[1]);
								$gv->$bkg_region_Y($_[2]);
							 	$gv->$bkg_region_R1($_[3]);
							 	$gv->$bkg_region_R2($_[4]);
								
								$bkg_expression = $bkg_expression." ((X,Y) IN $shape($_[1],$_[2],$_[3],$_[4])) ";
								$bkg_flag = 0;}	

							$gv->$src_expr($src_expression);
							$gv->$bkg_expr($bkg_expression);	
								
							print "SOURCE: $src_expression\n";
       						print "BACKGROUND: $bkg_expression\n";							    	
    						},
    	'ellipse'   => sub { print "Parsing a Ellipse\n";
    						$_[3] =~ s/"//;
    						$_[4] =~ s/"//;	
							$shape = uc($_[0]);												
							if ($bkg_flag eq 0)	{								
								if ($src_expression =~ /IN/) {$src_expression = $src_expression." && "; }
								if ($src_exclude_flag eq 1) {$src_expression = $src_expression."!";}
								$gv->$src_region($shape);
								$gv->$src_region_X($_[1]);
								$gv->$src_region_Y($_[2]);
							 	$gv->$src_region_R1($_[3]);
							 	$gv->$src_region_R2($_[4]);
							 	
								$src_expression = $src_expression." ((X,Y) IN $shape($_[1],$_[2],$_[3],$_[4],$_[5])) ";}													
							else {								
								if ($bkg_expression =~ /IN/) {$bkg_expression = $bkg_expression." && "; }
								if ($bkg_exclude_flag eq 1)  {$bkg_expression = $bkg_expression."!";}
								$bkg_expression = $bkg_expression." ((X,Y) IN $shape($_[1],$_[2],$_[3],$_[4],$_[5])) ";
								$bkg_flag = 0;
								$gv->$bkg_region($shape);
								$gv->$bkg_region_X($_[1]);
								$gv->$bkg_region_Y($_[2]);
							 	$gv->$bkg_region_R1($_[3]);
							 	$gv->$bkg_region_R2($_[4]);								
							}		

							$gv->$src_expr($src_expression);
							$gv->$bkg_expr($bkg_expression);	

							print "SOURCE: $src_expression\n";
       						print "BACKGROUND: $bkg_expression\n";							
					    	},
    	'box' => sub { print "Parsing a Box\n";
    						$_[3] =~ s/"//;
    						$_[4] =~ s/"//;	
							$shape = uc($_[0]);												
							if ($bkg_flag eq 0)	{								
								if ($src_expression =~ /IN/) {$src_expression = $src_expression." && "; }
								if ($src_exclude_flag eq 1) {$src_expression = $src_expression."!";}
								$gv->$src_region($shape);
								$gv->$src_region_X($_[1]);
								$gv->$src_region_Y($_[2]);
							 	$gv->$src_region_XLength($_[3]);
							 	$gv->$src_region_YLength($_[4]);
							 	
								$src_expression = $src_expression." ((X,Y)) IN $shape($_[1],$_[2],$_[3],$_[4],$_[5])) ";}													
							else {								
								if ($bkg_expression =~ /IN/) {$bkg_expression = $bkg_expression." && "; }
								if ($bkg_exclude_flag eq 1)  {$bkg_expression = $bkg_expression."!";}
								$gv->$bkg_region($shape);
								$gv->$bkg_region_X($_[1]);
								$gv->$bkg_region_Y($_[2]);
							 	$gv->$bkg_region_XLength($_[3]);
							 	$gv->$bkg_region_YLength($_[4]);		
								
								$bkg_expression = $bkg_expression." ((X,Y) IN $shape($_[1],$_[2],$_[3],$_[4],$_[5])) ";
								$bkg_flag = 0;}		

							$gv->$src_expr($src_expression);
							$gv->$bkg_expr($bkg_expression);	

							print "SOURCE: $src_expression\n";
       						print "BACKGROUND: $bkg_expression\n";							    	
    						},
    );
   

    if (($pid = fork) == 0)
       { 
       	#.. Columns to be shown
       	my $X = "X";
       	my $Y = "Y";
       	if (($mode eq "TimingEvts") )
      	{
          if ($instrument eq "pn")
       		{
       			$X = "RAWX";
       			$Y = "RAWY";
       		}
      	} 	 
# Run ds9
		if (&isRunning() == 1) {
         exec ("ds9 -title psechain_ds9 -cmap invert yes -cmap heat -scale log -coords physical -fits $fits_file -bin cols $X $Y -zoom to fit -bin about center"); }
 	     exit (1);
       }
       elsif ($pid > 0)
       {
 		
# Show the current Source and Background regions	
		$src_reg = $gv->$src_region;		
		$src_x = $gv->$src_region_X;		
		$src_y = $gv->$src_region_Y;
		$src_rad = $gv->$src_region_R2;
		$src_XL = $gv->$src_region_XLength;
		$src_YL = $gv->$src_region_YLength;
		$bkg_XL = $gv->$bkg_region_XLength;
		$bkg_YL = $gv->$bkg_region_YLength;
		if ( ($src_x != 0) && ($src_y != 0))
		{ 	
			$expre="";
			if ($mode eq "TimingEvts")
			{
				$expre = "$src_reg($src_x,$src_y,$src_XL,$src_YL,0) # color=white";
			}
			else				
			{
				$expre = "$src_reg($src_x,$src_y,$src_rad) # color=white";
			}

			$command = "physical; $expre"; 
        	&send($command);
		}

		$bkg_reg = $gv->$bkg_region;
		$bkg_x = $gv->$bkg_region_X;
		$bkg_y = $gv->$bkg_region_Y;
		$bkg_rad1 = $gv->$bkg_region_R1;
		$bkg_rad2 = $gv->$bkg_region_R2;
		if (($bkg_x != 0) && ($bkg_y != 0))
		{
			$expre="";
			if ($mode eq "TimingEvts")
			{
				$expre = "$bkg_reg($bkg_x,$bkg_y,$bkg_XL,$bkg_YL,0) # color=white background";
			}
			else
			{
				$expre = "$bkg_reg($bkg_x,$bkg_y,$bkg_rad1,$bkg_rad2) # color=white background";	
			}

			$command = "physical; $expre";        
    	    &send($command);
		}
       	
       	print "Create source and background region for high background filtering using PG optimization\n";
       	print "\"Y\"-> New regions. \"N\"-> Use default region  \n";
       	print "Press Y/N...: \n";
       	chomp( $key = <STDIN> );
		while ( ($key eq 'y' ) ||($key eq 'Y' ) )  
		{				
			$src_expression = '';
			$bkg_expression = '';
			
			@output = &receive();
		
    		print "RECEIVED: @output\n";
    		#parse the xpaget output    	
    		foreach my $line (@output) 
    		{
    			@words = split(' ',$line);
# Skip comments
    			if ( ( $words[0] eq "#") || (lc($words[0]) eq "global") )
    			{
    				print "GLOBAL: $line";
    			}	
    			elsif ( (lc($words[0]) eq "fk5") || (lc($words[0]) eq "physical") ) 
    			{
    				print "UNITS: $line";    				
    			}
    			else
    			{    			
	    			
	    			$line =~ s/\(|\)|,/  /g;
	    			print "LINE: $line";
# Background region	and check if it is a excluded region   			
	    			if ( $line =~ /background/) {
	    				$line =~ s/background/ /g; 
	    				$bkg_flag = 1;
	    				print "Background region\n";	    		
						if ($line =~ /^[\-]/) {
							$line =~ s/^[\-]//g;
							$bkg_exclude_flag = 1;
							print "Background excluded region\n";						
						}	    				    				
	    			}
# Source Exclude region
					if ($line =~ /^[\-]/) {
						$line =~ s/^[\-]//g;
						$src_exclude_flag = 1;
						print "Source excluded region\n";												
					}	    			
	    			@expr = split(' ',$line); 	    			
	    			
	    			$Switch{lc($expr[0])}->(@expr);
    			}    			
			}				
			if ( $gv->GTI_optimize_SN_flag eq "yes")
			{    			
				#.. Before Running PG optimization we have to check if we have already created the GTI needed 
				#.. for PG to run regions to create a bkg light curve to calculate the S/N
				@epicGTI=&test_epic_gtifile($instrument,$exposure,$mode);
		    	if (! $epicGTI[0]){	
		    		$PG_flagCall = 1;				
					&compute_gti;
		    	}    		
	    		&PG_gti_filter($instrument,$exposure,$mode);
			}
	   	
			
       		print "\"Y\"-> Repeat PG optimization with new regions. \"N\"-> Use the count rate obtained \n";
       		print "Press Y/N...: \n";
       		chomp( $key = <STDIN> );      		
    	}
		  
#close ds9 instance         
        kill 9 => $pid;
        
       }
       else
       {
         print ("Could not fork: errno is $!\n");
       }
    #my @args = ("ds9 -title psechain_ds9 -cmap invert yes -cmap b -cmap value 1.15 .13 -fits $fits_file -zoom to fit &");
    #system(@args);                   # == 0 or &error_code(5); NOTE: If I put this bit it wont run on the grid    

    return(1);

}

sub send()
{
	&waitForRunning();	
	`echo "$_[0]" | xpaset psechain_ds9 regions `;
	
}

sub receive()
{
	@output = `xpaget psechain_ds9 regions -format ds9 `;
	return (@output);
}

sub waitForRunning()
{		
	$output = `xpaget psechain_ds9 2>&1`;
	@error = split(' ',$output);

	while ($error[0] eq "XPA\$ERROR"  )
	{			
		$output = `xpaget psechain_ds9 2>&1`;
		@error = split(' ',$output);}				
}

sub isRunning()
{		
	$output = `xpaget psechain_ds9 2>&1`;
	@error = split(' ',$output);
	
	if ($error[0] eq "XPA\$ERROR"  ) { $flag = 1;	}
	else { $flag = 0;}
	
	return($flag);			
}



1;
