
sub prepare_spectra_log_file()
{
	my $instrument = $_[0];
	my $exposure = $_[1];
	my $mode = $_[2];
	
	my $source_name  = $gv->SRC_Name;
   	
   	my $src_region = "SPC_".$instrument."_srcregion";
   	my $bkg_region = "SPC_".$instrument."_bkgregion";

	#.. Source Regions...
 	my $src_region_X = "SPC_".$instrument."_srcregion_X";
    my $src_region_Y = "SPC_".$instrument."_srcregion_Y";
    my $src_region_R1 = "SPC_".$instrument."_srcregion_R1";
    my $src_region_R2 = "SPC_".$instrument."_srcregion_R2";
    my $src_region_XLength = "SPC_".$instrument."_srcregion_XLength";
    my $src_region_YLength = "SPC_".$instrument."_srcregion_YLength";
	#.. Bkg Regions...
    my $bkg_region_X = "SPC_".$instrument."_bkgregion_X";
    my $bkg_region_Y = "SPC_".$instrument."_bkgregion_Y";
    my $bkg_region_R1 = "SPC_".$instrument."_bkgregion_R1";
    my $bkg_region_R2 = "SPC_".$instrument."_bkgregion_R2";
    my $bkg_region_XLength = "SPC_".$instrument."_bkgregion_XLength";
    my $bkg_region_YLength = "SPC_".$instrument."_bkgregion_YLength";
	#.. Area Factor
	my $epic_areafactor = "SPC_".$instrument."_areafactor";
	
	my $spectrum_log=$results_directory."spectra_".$source_name."\.log";
	if (-e $spectrum_log) {unlink("$spectrum_log") or die "Cannot rm file: $!";}    
	open(SPECTRALOG, "> $spectrum_log") or die "Cant open output file: $! \n";    #open for write, overwrite
	
	print SPECTRALOG "   \#> Centroid of source to analyze (Physical Units) \n";
	print SPECTRALOG "       $instrument \n";
	print SPECTRALOG "         SRC Region : ",${%{$gv}}{$src_region},"\n";
	print SPECTRALOG "         SRC XC     : ", ${%{$gv}}{$src_region_X}," \n";
	print SPECTRALOG "         SRC YC     : ", ${%{$gv}}{$src_region_Y}," \n";
	if ( ${%{$gv}}{$src_region} eq "circle" ||  ${%{$gv}}{$src_region} eq "annulus")
	{print SPECTRALOG "         SRC RADII  : ", ${%{$gv}}{$src_region_R1}," - ", ${%{$gv}}{$src_region_R2}," \n";}
	if ( ${%{$gv}}{$src_region} eq "box") 
	{print SPECTRALOG "         SRC BOX    : ", ${%{$gv}}{$src_region_XLength}," - ", ${%{$gv}}{$src_region_YLength}," \n";}
	print SPECTRALOG "         BKG Region : ", ${%{$gv}}{$bkg_region},"\n";
	print SPECTRALOG "         BKG XC     : ", ${%{$gv}}{$bkg_region_X}," \n";
	print SPECTRALOG "         BKG YC     : ", ${%{$gv}}{$bkg_region_Y}," \n";
	if ( ${%{$gv}}{$src_region} eq "circle" ||  ${%{$gv}}{$src_region} eq "annulus") 
	{
	    print SPECTRALOG "         BKG RADII  : ", ${%{$gv}}{$bkg_region_R1}," - ", ${%{$gv}}{$bkg_region_R2}," \n";
	    if (${%{$gv}}{$src_region_R2} > ${%{$gv}}{$bkg_region_R1})
	    {print SPECTRALOG "         WARNING: PN regions : The inner background region radii is smaller than the source region radii \n";} 	    
	}
	if (${%{$gv}}{$src_region} eq "box") 
	{print SPECTRALOG "         BKG BOX    : ",${%{$gv}}{$bkg_region_XLength}," - ",${%{$gv}}{$bkg_region_YLength}," \n";}
	print SPECTRALOG "         BKG AREA SCALE FACTOR : ",${%{$gv}}{$epic_areafactor}," (Only area taken into account)\n";
	if (${%{$gv}}{$src_region_R2} == 6000){print SPECTRALOG  "         WARNING : PN regions : Maximum allowed radius reached";}

    
}
    
sub prepare_lcurve_log_file()
{
	my $instrument = $_[0];
	my $exposure = $_[1];
	my $mode = $_[2];
	
  	my $src_region = "LC_".$instrument."_srcregion";
   	my $bkg_region = "LC_".$instrument."_bkgregion";

	#.. Source Regions...
 	my $src_region_X = "LC_".$instrument."_srcregion_X";
    my $src_region_Y = "LC_".$instrument."_srcregion_Y";
    my $src_region_R1 = "LC_".$instrument."_srcregion_R1";
    my $src_region_R2 = "LC_".$instrument."_srcregion_R2";
    my $src_region_XLength = "LC_".$instrument."_srcregion_XLength";
    my $src_region_YLength = "LC_".$instrument."_srcregion_YLength";
	#.. Bkg Regions...
    my $bkg_region_X = "LC_".$instrument."_bkgregion_X";
    my $bkg_region_Y = "LC_".$instrument."_bkgregion_Y";
    my $bkg_region_R1 = "LC_".$instrument."_bkgregion_R1";
    my $bkg_region_R2 = "LC_".$instrument."_bkgregion_R2";
    my $bkg_region_XLength = "LC_".$instrument."_bkgregion_XLength";
    my $bkg_region_YLength = "LC_".$instrument."_bkgregion_YLength";	   
	#.. Area Factor
	my $epic_areafactor = "LC_".$instrument."_areafactor";
	   
	    print LCURVELOG "       PN \n";
	    print LCURVELOG "         SRC Region : ", $gv->$src_region,   "\n";
	    print LCURVELOG "         SRC XC     : ", $gv->$src_region_X, " \n";
	    print LCURVELOG "         SRC YC     : ", $gv->$src_region_Y, " \n";
	    if (   $gv->$src_region eq "circle"
		   || $gv->$src_region eq "annulus" ) {
	      print LCURVELOG "         SRC RADII  : ", $gv->$src_region_R1,
		" - ", $gv->$src_region_R2, " \n";
	    }
	    if ( $gv->$src_region eq "box" ) {
	      print LCURVELOG "         SRC ".$instrument."X    : ",
		$gv->$src_region_XLength, " - ", $gv->$src_region_YLength,
		  " \n";
	    }
	    print LCURVELOG "         BKG Region : ", $gv->$bkg_region,   "\n";
	    print LCURVELOG "         BKG XC     : ", $gv->$bkg_region_X, " \n";
	    print LCURVELOG "         BKG YC     : ", $gv->$bkg_region_Y, " \n";
	    if (   $gv->$bkg_region eq "circle"
		   || $gv->$bkg_region eq "annulus" ) {
	      print LCURVELOG "         BKG RADII  : ", $gv->$bkg_region_R1,
		" - ", $gv->$bkg_region_R2, " \n";
	      if ( $gv->$src_region_R2 > $gv->$bkg_region_R1 ) {
		print LCURVELOG
		  "         WARNING: PN regions : The inner background region radii is smaller than the source region radii \n";
	      }
	    }
	    
	    if ( $gv->$bkg_region eq "box" ) {
	      print LCURVELOG "         BKG BOX    : ",
		$gv->$bkg_region_XLength, " - ", $gv->$bkg_region_YLength,
		  " \n";
	    }
	    print LCURVELOG "         BKG AREA SCALE FACTOR : ",
	      $gv->$epic_areafactor, " (Only area taken into account)\n";
	    if ( $gv->$src_region_R2 == 6000 ) {
	      print LCURVELOG
		"         WARNING : PN regions : Maximum allowed radius reached";
	    }
	
}

1;
